<template>
  <promotion-type
    :menu="'top'"
    v-loading="isLoading"
    class="container grid gap-5 mx-auto my-10"
  >
    <template v-slot:category>
      <div class="flex gap-5">
        <el-menu
          :default-active="IsActive"
          class="w-full border-0 el-menu-demo"
          mode="horizontal"
          text-color="var(--text)"
          active-text-color="var(--secondary)"
          background-color="var(--background1)"
        >
          <el-menu-item
            v-for="(promoGroup, index) in promotionGroup"
            :key="index"
            :index="index"
          >
            <span
              class="mx-6 cursor-pointer nav-main-cont"
              @click="onClickPromotion(promoGroup.label)"
            >
              {{ promoGroup.Type }}
            </span>
            <el-divider
              v-show="index !== Object.keys(promotionGroup).length - 1"
              direction="vertical"
            />
          </el-menu-item>
        </el-menu>
      </div>
    </template>
    <template v-slot:content>
      <div
        class="grid grid-cols-3 mx-auto h-fit gap-x-[12px] gap-y-[24px] w-[1200px]"
      >
        <div
          v-for="promotion in promotionListForDisplay"
          :key="promotion.Id"
          class="min-h-[380px]"
        >
          <promotion-vertical-card
            :promotion="promotion"
            :button-apply-promotion-enabled="buttonApplyPromotionEnabled"
            :authenticated="authenticated"
            :on-apply-promotion="onApplyPromotion"
            :is-processing="isProcessing"
            :is-applying="applyRequest.PromotionId === promotion.Id"
            :on-click-spin-now="onClickSpinNow"
            :validateLuckyWheelbutton="validateLuckyWheelbutton(promotion)"
          />
        </div>
        <div
          v-if="promotions.length === 0 || promotionListForDisplay.length === 0"
          class="flex flex-col justify-center items-center my-[60px] col-span-3 overflow-hidden"
        >
          <div class="text-4xl text-center truncate no-data text-ellipsis">
            {{ $t("no_promotion_info") }}
          </div>
          <span class="font-bold text-lg fc-text">{{ assignHashText }}</span>
        </div>
      </div>
    </template>
  </promotion-type>
</template>

<script lang="ts">
import { defineComponent, ref } from "vue";

export default defineComponent({
  name: "Promotion",
  setup() {
    const IsActive = ref(0);
    const {
      promotions,
      isDialogVisible,
      onMoreInformation,
      authenticated,
      promotionModel,
      isProcessing,
      onApplyPromotion,
      buttonApplyPromotionEnabled,
      isLoading,
      promotionGroup,
      selectedType,
      promotionListForDisplay,
      onClickPromotion,
      assignHashText,
      applyRequest,
      onClickSpinNow,
      validateLuckyWheelbutton,
    } = usePromotion();
    return {
      IsActive,
      promotions,
      isDialogVisible,
      onMoreInformation,
      authenticated,
      promotionModel,
      isProcessing,
      onApplyPromotion,
      buttonApplyPromotionEnabled,
      isLoading,
      promotionGroup,
      selectedType,
      promotionListForDisplay,
      onClickPromotion,
      assignHashText,
      applyRequest,
      onClickSpinNow,
      validateLuckyWheelbutton,
    };
  },
});
</script>

<style>
.el-divider--vertical {
  border-left: 1px var(--text3) var(--el-border-style);
}
.active:hover {
  color: var(--primary);
}
</style>
<style scoped>
div[theme-color="black"] .el-menu {
  background: unset;
}
div[theme-color="black"] .el-menu-item:first-child > span {
  margin-left: 0;
}
.el-menu-item {
  padding: 0;
  border: 0;
  font-size: 14px;
  font-weight: 700;
}
.el-menu--horizontal {
  border: 0;
}
:deep(.el-menu-item:hover) {
  background: none !important;
  color: var(--secondary) !important;
}
.el-menu--horizontal > .el-menu-item.is-active {
  border: 0 !important;
  background: none !important;
}
.el-divider--vertical {
  margin: 0;
}
</style>
